=begin

Copyright 2007, Rick Wilson 

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

Name:				CameraDistance
Description:	Returns the distance to an object in the direct line of sight. 
Author:			Rick Wilson
Usage:
	1. Install into the plugins directory
	2. Camera>Distance to object


Date :		2007-09-07
Type :		Tool
History:
    1.0 (2007-09-07) - first version

=end

require "sketchup.rb"

class Sketchup::Camera

	def parent
		return Sketchup.active_model
	end

	def object_distance
		@model = parent
		result = @model.raytest(eye,target-eye)
		if result
			dist = result.first.distance(eye)
		else
			dist = nil
		end
		return dist
	end

end


unless file_loaded?("CameraDistance.rb")
   UI.menu("Camera").add_item("Distance to Object") {(result = Sketchup.active_model.active_view.camera.object_distance) ? UI.messagebox("Distance: #{result}", MB_MULTILINE, "Camera Distance to Object") : UI.messagebox("No object in the direct line of sight")} 
	file_loaded("CameraDistance.rb")
end
